package com.maroontress.madangler.client;

import com.google.gwt.xml.client.Attr;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NamedNodeMap;
import com.google.gwt.xml.client.XMLParser;
import java.util.HashMap;

/**
   󥯤ɽ饹Ǥ

   ɽƤ륵֥ѥͥȤ֤XMLǤ˥ꥢ饤
   ꡢεդ򤹤뤿˻Ѥޤѿ̾typeϥ֥ѥͥꤹ
   ˻Ѥޤʳѿϥ֥ѥͥ˰¸ޤ
*/
public class Link {

    /** ѿ̾ͤΥޥå */
    private HashMap propertyMap;

    /**
       Υ󥯤ޤ
    */
    public Link() {
        propertyMap = new HashMap();
    }

    /**
       ֥ѥͥ򼨤󥯤ޤ

       @param type ֥ѥͥ򼨤ʸ
    */
    public Link(final String type) {
        propertyMap = new HashMap();
	propertyMap.put("type", type);
    }

    /**
       XML˥פ줿ʸ֤ޤ

       @param s ʸ
       @return XML˥פ줿ʸ
    */
    private String escaped(final String s) {
	// config/ConfigModel.javaˤ⤢ -> XML饹
	return s.replaceAll("&", "&amp;")
	    .replaceAll("<", "&lt;")
	    .replaceAll(">", "&gt;")
	    .replaceAll("\"", "&quot;");
    }

    /**
       ѿɲäޤ

       ǤƱ̾ѿ¸ߤϾ񤭤ޤvaluenullΤ
       ѿޤ

       @param key ѿ̾
       @param value 
    */
    public void addParameter(final String key, final String value) {
	if (value == null) {
	    propertyMap.remove(key);
	    return;
	}
	propertyMap.put(key, value);
    }

    /**
       ѿͤޤ

       @param key ѿ̾
       @return 
    */
    public String getParameter(final String key) {
	return (String) propertyMap.get(key);
    }

    /**
       󥯤XMLǤ˥ꥢ饤ޤ

       @return XMLΥ
    */
    public String encode() {
	String xml = "<link";
	Object[] key = propertyMap.keySet().toArray();
	for (int k = 0; k < key.length; ++k) {
	    String name = (String) key[k];
	    String value = (String) propertyMap.get(name);
	    xml += " " + name + "=\"" + escaped(value) + "\"";
	}
	xml += "/>";
	return xml;
    }

    /**
       ʸǥꥢ饤ƥ󥯤ޤ

       @param token XMLΥ
       @return 
    */
    public static Link decode(final String token) {
	Link link = new Link();
	try {
	    Document d = XMLParser.parse(token);
	    Element elem = d.getDocumentElement();
	    if (!elem.getTagName().equals("link")) {
		return null;
	    }
	    NamedNodeMap map = elem.getAttributes();
	    for (int k = 0; k < map.getLength(); ++k) {
		Attr attr = (Attr) map.item(k);
		link.addParameter(attr.getName(), attr.getValue());
	    }
	} catch (DOMException e) {
	    return null;
        }
	return link;
    }
}
