#!/bin/sh

# Parameters:
#   HTTP_HOST: URLΥۥʬ (Apache)
#   MAIL_ENABLED: ᡼YES
#   SCRIPT_NAME: URLΥѥʬ (Apache)
#   SERVER_PORT: URLΥݡʬ (Apache)
#   projectId: ץID
#   result: OK/NG
#   revision: ӥ
#   serial: ꥢ

print_report()
{
cat <<EOF
Project: $projectId
Revision: $revision
Result: $result

Log:
$url

Mad Angler:
$base/index.html
EOF
}

case "$MAIL_ENABLED" in
YES)
  ;;
*)
  exit
  ;;
esac

case "$result" in
OK)
  m="BUILD SUCCEEDED"
  ;;
NG)
  m="BUILD FAILED"
  ;;
esac

subject="[$projectId] $m: Rev. $revision"
base="http://${HTTP_HOST}"
case "$SERVER_PORT" in
80)
  ;;
*)
  base="${base}:$SERVER_PORT"
  ;;
esac
base="${base}${SCRIPT_NAME%/*}"

url="$base/MadAngler.html#%3Clink%20type%3D%22buildLog%22%20id%3D%22"
url="${url}${urlEncodedProjectId}"
url="${url}%22%20serial%3D%22"
url="${url}${serial}"
url="${url}%22%2F%3E"

# TODO: $subjectMIME󥳡ɤ
print_report | mail -s "$subject" "${RCPT_TO}" -F"${MAIL_FROM}"
