#include <stdlib.h>
#include <stdio.h>
#include "Serial.h"

struct Serial {
    int num;
    char key[16];
};

struct Serial *
Serial_create(int num)
{
    struct Serial *s;

    if ((s = (struct Serial *)malloc(sizeof(*s))) == NULL)
	return NULL;
    Serial_setInt(s, num);
    return s;
}

void
Serial_free(struct Serial *s)
{
    free(s);
}

void
Serial_setInt(struct Serial *s, int num)
{
    s->num = num;
    snprintf(s->key, sizeof(s->key), "%15d", num);
}

int
Serial_getInt(struct Serial *s)
{
    return s->num;
}

char *
Serial_getKey(struct Serial *s)
{
    return s->key;
}
